import ImmutableXController from "../controller";
import { Signer } from '@ethersproject/abstract-signer';
import { PopulatedTransaction } from '@ethersproject/contracts';
import { Token } from '@imtbl/imx-link-types';
import * as TE from 'fp-ts/lib/TaskEither';
/**
 * Immutable X Wallet
 */
export declare class ImmutableXWallet {
    controller: ImmutableXController;
    private signer;
    constructor(signer: Signer, accountMappingKey?: string);
    incrementNonce(): void;
    getEthKey(contractAddress: string, starkPublicKey: string): Promise<string>;
    getDepositBalance(contractAddress: string, starkPublicKey: string, token: Token, vaultId: string): Promise<string>;
    getWithdrawalBalance(contractAddress: string, starkPublicKey: string, token: Token): Promise<string>;
    setupNFT(nftContractAddress: string, contractAddress: string, to: string, tokenId: string, tokenUri: string): Promise<string>;
    resolve(payload: any): Promise<any>;
    sendTransactionF(unsignedTrx: PopulatedTransaction, gasLimit?: string, gasPrice?: string): TE.TaskEither<Error, string>;
    sendTransaction(unsignedTrx: PopulatedTransaction, gasLimit?: string, gasPrice?: string): Promise<string>;
}
export default ImmutableXWallet;
//# sourceMappingURL=index.d.ts.map