import { Signer } from '@ethersproject/abstract-signer';
import { BaseProvider } from '@ethersproject/providers';
import { BotEnvironment, ETHToken, ETHTokenType, PositiveIntegerString, PositiveNumberString } from '@imtbl/imx-link-types';
import { Lazy } from 'fp-ts/function';
import * as E from 'fp-ts/lib/Either';
import * as TE from 'fp-ts/lib/TaskEither';
import { Errors } from 'io-ts';
import * as t from 'io-ts';
import { UserWallet } from './types';
export declare function payloadId(): number;
export declare function formatError(err: any): Error;
export declare function validateRPCResult(data: any): any;
export declare function generateWallet(env: BotEnvironment, index: string, privateKey?: string, provider?: BaseProvider, signer?: Signer): Promise<UserWallet>;
export declare function sleep(time: number): Promise<unknown>;
export declare const getEthToken: (quantum: number) => E.Either<Errors, ETHToken>;
export declare const eth8Token: {
    type: ETHTokenType;
    data: {
        quantum: t.Branded<string, import("@imtbl/imx-link-types").PositiveIntegerStringBrand>;
    };
};
export declare const errorsToError: (errors: t.Errors) => Error;
export declare function errorsToArray(errors: t.Errors): Error[];
export declare const switchCase: <T extends string | number | symbol, U>(value: T, cases: Record<T, Lazy<U>>, def: Lazy<U>) => U;
export declare const ethToEth8: (amount: string) => E.Either<Errors, PositiveIntegerString>;
export declare const eth8ToEth: (amount: string) => E.Either<Errors, PositiveNumberString>;
export declare function decodeForFunction<T, U>(params: any, decode: (x: any) => E.Either<Errors, T>, fn: (params: T) => TE.TaskEither<Error, U>): Promise<U>;
//# sourceMappingURL=utils.d.ts.map